package xyz.lychee.lagfixer.libs.adventure.util;

import java.util.Iterator;
import java.util.Objects;
import java.util.Spliterator;
import java.util.function.Supplier;
import xyz.lychee.lagfixer.libs.annotations.NotNull;

public final class ForwardingIterator<T> implements Iterable<T> {
   private final Supplier<Iterator<T>> iterator;
   private final Supplier<Spliterator<T>> spliterator;

   public ForwardingIterator(final @NotNull Supplier<Iterator<T>> iterator, final @NotNull Supplier<Spliterator<T>> spliterator) {
      this.iterator = (Supplier)Objects.requireNonNull(iterator, "iterator");
      this.spliterator = (Supplier)Objects.requireNonNull(spliterator, "spliterator");
   }

   public @NotNull Iterator<T> iterator() {
      return (Iterator)this.iterator.get();
   }

   public @NotNull Spliterator<T> spliterator() {
      return (Spliterator)this.spliterator.get();
   }
}
